<template>
    <div>
        <form @submit.prevent="onSubmit">
            <div class="row m-t-sm">
                <div class="col-lg-12">
                    <div class="panel blank-panel">
                        <div class="panel-heading">
                            <div class="panel-options">
                                <ul class="nav nav-tabs">
                                    <li class="active"><a href="#tab-1" data-toggle="tab">Dados Gerais</a></li>
                                    <li class=""><a href="#tab-2" data-toggle="tab">Detalhes</a></li>
                                    <li class=""><a href="#tab-3" data-toggle="tab">Valores/Estoque</a></li>
                                    <li class=""><a href="#tab-4" data-toggle="tab">Imagem</a></li>
                                    <li class="" v-if="formData.emitir_nf">
                                        <a href="#tab-5" data-toggle="tab">Fiscal</a>
                                    </li>
                                    <li class="">
                                        <a href="#tab-6" data-toggle="tab" @click="loadProviders()">Fornecedores</a>
                                    </li>
                                </ul>
                            </div>
                        </div>

                        <div class="panel-body">

                            <div class="tab-content">

                                <!-- Dados Gerais -->
                                <div class="tab-pane active" id="tab-1">
                                    <div class="col-md-12">
                                        <div class="form-group col-md-6" :class="{'has-error' : errors_product.nome}">
                                            <label>Nome<b class="text-danger">*</b></label>
                                            <input type="text" class="form-control" v-model="formData.nome">
                                            <label class="error"
                                                   v-if="errors_product.nome">{{errors_product.nome[0]}}</label>
                                        </div>

                                        <div class="form-group col-md-3"
                                             :class="{'has-error' : errors_product.codigo_interno}">
                                            <label>Código interno <b class="text-danger">*</b></label>
                                            <div class="input-group">
                                                <input type="text" class="form-control"
                                                       v-model="formData.codigo_interno">
                                                <div class="input-group-btn">
                                                    <button class="btn btn-primary"
                                                            @click.prevent="gerarCodigoInterno()">
                                                        <i class="fa fa-refresh"></i> Gerar
                                                    </button>
                                                </div>
                                            </div>
                                            <label class="error" v-if="errors_product.codigo_interno">
                                                {{errors_product.codigo_interno[0]}}</label>
                                        </div>

                                        <div class="form-group col-md-3"
                                             :class="{'has-error' : errors_product.codigo_barras}">
                                            <label>Código de barras</label>
                                            <input type="text" class="form-control" v-model="formData.codigo_barras">
                                            <label class="error" v-if="errors_product.codigo_barras">
                                                {{errors_product.codigo_barras[0]}}</label>
                                        </div>
                                    </div>

                                    <div class="col-md-12">
                                        <div class="form-group col-md-3"
                                             :class="{'has-error' : errors_product.product_category_id}">
                                            <label>Grupo do produto<b class="text-danger">*</b></label>
                                            <select class="form-control" v-model='formData.product_category_id'
                                                    v-select2>
                                                <option value="" disabled>--Selecione--</option>
                                                <option v-for="category in categories" :value="category.id">
                                                    {{category.name}}
                                                </option>
                                            </select>
                                            <label class="error" v-if="errors_product.product_category_id">
                                                {{errors_product.product_category_id[0]}}</label>
                                        </div>

                                        <div class="form-group col-md-3"
                                             :class="{'has-error' : errors_product.movimenta_estoque}">
                                            <label>Movimenta estoque?</label>
                                            <select class="form-control" v-model="formData.movimenta_estoque">
                                                <option :value="true">Sim</option>
                                                <option :value="false">Nao</option>
                                            </select>
                                            <label class="error" v-if="errors_product.movimenta_estoque">
                                                {{errors_product.movimenta_estoque[0]}}</label>
                                        </div>


                                        <div class="form-group col-md-3"
                                             :class="{'has-error' : errors_product.emitir_nf}">
                                            <label>Habilitar nota fiscal?</label>
                                            <select class="form-control" v-model="formData.emitir_nf">
                                                <option :value="false">Não</option>
                                                <option :value="true">Sim</option>
                                            </select>
                                            <label class="error" v-if="errors_product.emitir_nf">
                                                {{errors_product.emitir_nf[0]}}</label>
                                        </div>

                                        <div class="form-group col-md-3"
                                             :class="{'has-error' : errors_product.possui_variacao}">
                                            <label>Possui variações?</label>
                                            <select class="form-control" v-model="formData.possui_variacao">
                                                <option :value="false">Não</option>
                                                <option :value="true">Sim</option>
                                            </select>
                                            <label class="error" v-if="errors_product.possui_variacao">
                                                {{errors_product.possui_variacao[0]}}</label>
                                        </div>
                                    </div>

                                    <div class="col-md-12">
                                        <div class="form-group col-md-3"
                                             :class="{'has-error' : errors_product.ativo}">
                                            <label>Produto ativo?</label>
                                            <select class="form-control" v-model="formData.ativo">
                                                <option :value="true">Sim</option>
                                                <option :value="false">Nao</option>
                                            </select>
                                            <label class="error" v-if="errors_product.ativo">
                                                {{errors_product.ativo[0]}}</label>
                                        </div>

                                        <div class="form-group col-md-3"
                                             :class="{'has-error' : errors_product.comissao}">
                                            <label>Comissão (%)</label>
                                            <money class="form-control" v-model="formData.comissao"></money>
                                            <label class="error" v-if="errors_product.comissao">
                                                {{errors_product.comissao[0]}}</label>
                                        </div>

                                        <div class="form-group col-md-3"
                                             :class="{'has-error' : errors_product.possui_juros}">
                                            <label>Possui juros?</label>
                                            <select class="form-control" v-model="formData.possui_juros">
                                                <option :value="false">Não</option>
                                                <option :value="true">Sim</option>
                                            </select>
                                            <label class="error" v-if="errors_product.possui_juros">
                                                {{errors_product.possui_juros[0]}}</label>
                                        </div>

                                        <div class="form-group col-md-3" v-if="formData.possui_juros"
                                             :class="{'has-error' : errors_product.juros}">
                                            <label>Juros ao mês (%)</label>
                                            <money class="form-control" v-model="formData.juros"></money>
                                            <label class="error" v-if="errors_product.juros">
                                                {{errors_product.juros[0]}}</label>
                                        </div>

                                        <div class="form-group col-md-3"
                                             :class="{'has-error' : errors_product.unity_id}">
                                            <label>Unidade de medida</label>
                                            <select class="form-control" v-model="formData.unity_id" v-select2>
                                                <option value="" disabled>--Selecione--</option>
                                                <option v-for="unity in unities" :value="unity.id">
                                                    {{unity.sigla | uppercase}}
                                                </option>
                                            </select>
                                            <label class="error" v-if="errors_product.unity_id">
                                                {{errors_product.unity_id[0]}}</label>
                                        </div>
                                    </div>
                                </div>

                                <!-- Detalhes -->
                                <div class="tab-pane" id="tab-2">
                                    <div class="col-md-12">
                                        <div class="form-group col-md-3"
                                             :class="{'has-error' : errors_product.peso}">
                                            <label>Peso (Kg)</label>
                                            <money class="form-control" v-model="formData.peso"></money>
                                            <label class="error" v-if="errors_product.peso">
                                                {{errors_product.peso[0]}}</label>
                                        </div>
                                        <div class="form-group col-md-3"
                                             :class="{'has-error' : errors_product.largura}">
                                            <label>Largura (m)</label>
                                            <money class="form-control" v-model="formData.largura"></money>
                                            <label class="error" v-if="errors_product.largura">
                                                {{errors_product.largura[0]}}</label>
                                        </div>
                                        <div class="form-group col-md-3" :class="{'has-error' : errors_product.altura}">
                                            <label>Altura (m)</label>
                                            <money class="form-control" v-model="formData.altura"></money>
                                            <label class="error" v-if="errors_product.altura">
                                                {{errors_product.altura[0]}}</label>
                                        </div>
                                        <div class="form-group col-md-3"
                                             :class="{'has-error' : errors_product.cumprimento}">
                                            <label>Cumprimento (m)</label>
                                            <money class="form-control" v-model="formData.cumprimento"></money>
                                            <label class="error" v-if="errors_product.cumprimento">
                                                {{errors_product.cumprimento[0]}}</label>
                                        </div>
                                    </div>

                                    <div class="col-md-12">
                                        <div class="form-group col-md-12"
                                             :class="{'has-error' : errors_product.observacao}">
                                            <label>Observações</label>
                                            <textarea cols="30" rows="10" class="form-control"
                                                      v-model="formData.observacao"></textarea>
                                            <label class="error" v-if="errors_product.observacao">
                                                {{errors_product.observacao[0]}}</label>
                                        </div>
                                    </div>
                                </div>

                                <!-- Valores / Estoque -->
                                <div class="tab-pane" id="tab-3">
                                    <div class="col-md-3" v-if="formData.possui_variacao">
                                        <div class="form-group">
                                            <button class="btn btn-primary" @click.prevent="addGrid()">
                                                <i class="fa fa-plus-circle"></i> Adicionar variação
                                            </button>
                                        </div>
                                    </div>
                                    <div class="col-md-9 text-right form-inline" v-if="formData.possui_variacao">
                                        <span v-for="(grid, index) in grids">
                                            <input type="checkbox" :id="grid.id" :value="grid" class="checkbox"
                                                   v-model="grades" v-icheck @change="addVariation(grades)"/>
                                            <label>{{grid.name}}</label>
                                        </span>
                                    </div>
                                    <div v-for="(product_grid, index) in formData.product_grids">
                                        <div class="label-form col-md-12">
                                            <div class="col-md-12 text-right" v-if="formData.possui_variacao">
                                                <a href="#" @click.prevent="removeGrid(index)">
                                                    <b class="text-danger">remover</b>
                                                </a>
                                            </div>
                                            <div class="col-md-3">
                                                <div class="form-group col-md-12"
                                                     :class="{'has-error' : errors_product_grids.errors.valor_custo &&
                                                                            index == errors_product_grids.key}">
                                                    <label>Valor de custo<b class="text-danger">*</b></label>
                                                    <div class="input-group">
                                                        <div class="input-group-addon">
                                                            R$
                                                        </div>
                                                        <money class="form-control"
                                                               v-model="product_grid.valor_custo"></money>
                                                    </div>
                                                    <label class="error" v-if="errors_product_grids.errors.valor_custo &&
                                                                                index == errors_product_grids.key">
                                                        {{errors_product_grids.errors.valor_custo[0]}}
                                                    </label>
                                                </div>
                                                <div class="form-group col-md-12"
                                                     :class="{'has-error' : errors_product_grids.errors.valor_despesas &&
                                                                            index == errors_product_grids.key}">
                                                    <label>Despesas</label>
                                                    <div class="input-group">
                                                        <div class="input-group-addon">
                                                            R$
                                                        </div>
                                                        <money class="form-control"
                                                               v-model="product_grid.valor_despesas"></money>
                                                    </div>
                                                    <label class="error" v-if="errors_product_grids.errors.valor_despesas &&
                                                                                index == errors_product_grids.key">
                                                        {{errors_product_grids.errors.valor_despesas[0]}}
                                                    </label>
                                                </div>
                                                <div class="form-group col-md-12"
                                                     :class="{'has-error' : errors_product_grids.errors.valor_custo_final &&
                                                                            index == errors_product_grids.key}">
                                                    <label>Custo final<b class="text-danger">*</b></label>
                                                    <div class="input-group">
                                                        <div class="input-group-addon">
                                                            R$
                                                        </div>
                                                        <money class="form-control" disabled
                                                               v-model="product_grid.valor_custo_final"></money>
                                                    </div>
                                                    <label class="error" v-if="errors_product_grids.errors.valor_custo_final &&
                                                                                index == errors_product_grids.key">
                                                        {{errors_product_grids.errors.valor_custo_final[0]}}
                                                    </label>
                                                </div>
                                            </div>
                                            <div class="col-md-3">
                                                <div class="form-group col-md-12" v-if="formData.possui_variacao"
                                                     :class="{'has-error' : errors_product_grids.errors.codigo_identificacao &&
                                                                            index == errors_product_grids.key}">
                                                    <label>Código identificação <b class="text-danger">*</b></label>
                                                    <div class="input-group">
                                                        <input type="text" class="form-control"
                                                               v-model="product_grid.codigo_identificacao">
                                                        <div class="input-group-btn">
                                                            <button class="btn btn-primary"
                                                                    @click.prevent="gerarCodigoIdentificacao(index)">
                                                                <i class="fa fa-refresh"></i> Gerar
                                                            </button>
                                                        </div>
                                                    </div>
                                                    <label class="error" v-if="errors_product_grids.errors.codigo_identificacao &&
                                                                                index == errors_product_grids.key">
                                                        {{errors_product_grids.errors.codigo_identificacao[0]}}
                                                    </label>
                                                </div>
                                                <div class="form-group col-md-12"
                                                     :class="{'has-error' : errors_product_grids.errors.porcentagem_lucro &&
                                                                            index == errors_product_grids.key}">
                                                    <label>Lucro utilizado (%)<b class="text-danger">*</b></label>
                                                    <div class="input-group">
                                                        <div class="input-group-btn">
                                                            <button class="btn btn-primary"
                                                                    @click.prevent="calcularVenda(index)">
                                                                <i class="fa fa-calculator"></i>
                                                            </button>
                                                        </div>
                                                        <money class="form-control"
                                                               v-model="product_grid.porcentagem_lucro"></money>
                                                        <div class="input-group-btn">
                                                            <button class="btn btn-white" disabled>
                                                                %
                                                            </button>
                                                        </div>
                                                    </div>
                                                    <label class="error" v-if="errors_product_grids.errors.porcentagem_lucro &&
                                                                                index == errors_product_grids.key">
                                                        {{errors_product_grids.errors.porcentagem_lucro[0]}}
                                                    </label>
                                                </div>
                                                <div class="form-group col-md-12"
                                                     :class="{'has-error' : errors_product_grids.errors.valor_venda &&
                                                                            index == errors_product_grids.key}">
                                                    <label>Valor da venda<b class="text-danger">*</b></label>
                                                    <div class="input-group">
                                                        <div class="input-group-btn">
                                                            <button class="btn btn-white" disabled>
                                                                R$
                                                            </button>
                                                        </div>
                                                        <money class="form-control"
                                                               v-model="product_grid.valor_venda"></money>
                                                        <div class="input-group-btn">
                                                            <button class="btn btn-primary"
                                                                    @click.prevent="calcularPorcentagem(index)">
                                                                <i class="fa fa-calculator"></i>
                                                            </button>
                                                        </div>
                                                    </div>
                                                    <label class="error" v-if="errors_product_grids.errors.valor_venda &&
                                                                                index == errors_product_grids.key">
                                                        {{errors_product_grids.errors.valor_venda[0]}}
                                                    </label>
                                                </div>
                                            </div>
                                            <div class="col-md-3">
                                                <div class="form-group col-md-12"
                                                     :class="{'has-error' : errors_product_grids.errors.estoque_minimo &&
                                                                            index == errors_product_grids.key}">
                                                    <label>Estoque minimo<b class="text-danger">*</b></label>
                                                    <input type="number" class="form-control"
                                                           v-model.number="product_grid.estoque_minimo">
                                                    <label class="error" v-if="errors_product_grids.errors.estoque_minimo &&
                                                                                index == errors_product_grids.key">
                                                        {{errors_product_grids.errors.estoque_minimo[0]}}
                                                    </label>
                                                </div>
                                                <div class="form-group col-md-12"
                                                     :class="{'has-error' : errors_product_grids.errors.estoque_maximo &&
                                                                            index == errors_product_grids.key}">
                                                    <label>Estoque máximo<b class="text-danger">*</b></label>
                                                    <input type="number" class="form-control"
                                                           v-model.number="product_grid.estoque_maximo">
                                                    <label class="error" v-if="errors_product_grids.errors.estoque_maximo &&
                                                                                index == errors_product_grids.key">
                                                        {{errors_product_grids.errors.estoque_maximo[0]}}
                                                    </label>
                                                </div>
                                                <div class="form-group col-md-12"
                                                     :class="{'has-error' : errors_product_grids.errors.estoque_atual &&
                                                                            index == errors_product_grids.key}">
                                                    <label>Estoque atual<b class="text-danger">*</b></label>
                                                    <input type="number" class="form-control"
                                                           v-model.number="product_grid.estoque_atual">
                                                    <label class="error" v-if="errors_product_grids.errors.estoque_atual &&
                                                                                index == errors_product_grids.key">
                                                        {{errors_product_grids.errors.estoque_atual[0]}}
                                                    </label>
                                                </div>
                                            </div>

                                            <div v-for="(grade, index) in product_grid.variations"
                                                 class="col-md-3 ">
                                                <div class="form-group col-md-12">
                                                    <label>{{grade.gradeName}}<b class="text-danger">*</b></label>
                                                    <select type="text" class="form-control"
                                                            v-model="grade.variation_id">
                                                        <option value="">--Selecione--</option>
                                                        <option v-for="variation in grade.variations"
                                                                :value="variation.id">{{variation.name}}
                                                        </option>
                                                    </select>
                                                </div>
                                            </div>
                                        </div>
                                    </div>
                                </div>

                                <!-- Imagem -->
                                <div class="tab-pane" id="tab-4">
                                    <div class="jumbotron text-center row">

                                        <div v-if="formData.imagem">
                                            <div class="col-md-12">
                                                <img :src="[`/storage/tenants/${tenant.uuid}/products/${formData.imagem}`]"
                                                     class="img-thumbnail image-preview">
                                            </div>
                                            <div class="col-md-12">
                                                <button class="btn btn-danger" v-if="formData.imagem"
                                                        @click.prevent="removeImageData">
                                                    <i class="fa fa-trash"></i> Remover imagem
                                                </button>
                                                <span class="btn btn-primary btn-file" v-else>
                                                <i class="fa fa-folder-open"></i> Selecione uma imagem
                                                <input type="file" @change="onImage">
                                            </span>
                                            </div>
                                        </div>

                                        <div v-else>
                                            <div class="col-md-12" v-if="imagePreview">
                                                <img :src="imagePreview" class="img-thumbnail image-preview">
                                            </div>

                                            <div class="col-md-12" v-else>
                                                <img src="https://www.freeiconspng.com/uploads/no-image-icon-6.png"
                                                     alt="" class="img-thumbnail image-preview">
                                            </div>

                                            <div class="col-md-12">
                                                <button class="btn btn-danger" v-if="imagePreview"
                                                        @click.prevent="removeImagePreview">
                                                    <i class="fa fa-trash"></i> Remover imagem
                                                </button>
                                                <span class="btn btn-primary btn-file" v-else>
                                                <i class="fa fa-folder-open"></i> Selecione uma imagem
                                                <input type="file" @change="onImage">
                                            </span>
                                            </div>
                                        </div>


                                        <p class="text-danger" v-if="errors_product.imagem">
                                            {{errors_product.imagem[0]}}
                                        </p>
                                    </div>
                                </div>

                                <!-- Fiscal -->
                                <div class="tab-pane" id="tab-5" v-if="formData.emitir_nf">
                                </div>

                                <!-- Fornecedores -->
                                <div class="tab-pane" id="tab-6">
                                    <div class="form-group col-md-12"
                                         :class="{'has-error' : errors_product.provider_id}">
                                        <label>Fornecedor:</label>
                                        <select class="form-control"
                                                v-model='formData.provider_id' v-select2>
                                            <option value="">--Selecione--</option>
                                            <option v-for="provider in providers" :value="provider.id">
                                                {{provider.name}}
                                            </option>
                                        </select>
                                        <label class="error" v-if="errors_product.provider_id">
                                            {{errors_product.provider_id[0]}}</label>
                                    </div>
                                </div>

                            </div>

                        </div>

                    </div>
                </div>
            </div>

            <div class="col-sm-12 text-center">
                <div class="hr-line-dashed"></div>
                <button class="btn btn-white" type="button" @click.prevent="backPage" :disabled="isBtnPreload">
                    <i class="fa fa-reply"></i> Voltar
                </button>
                <button class="btn btn-primary" type="submit" :disabled="isBtnPreload">
                    <i v-if="isBtnPreload" class="fa fa-circle-o-notch fa-spin"></i>
                    <i class="fa fa-save" v-else></i>
                    Salvar
                </button>
            </div>

        </form>
    </div>
</template>

<script>
    import moment from 'moment'

    export default {
        props: {
            isUpdate: {
                require: false,
                type: Boolean,
                default: false,
            },

            checkGrades: {
                require: false,
                default: false,
            },

            formData: {
                require: false,
                type: Object,
                default: () => {
                    return {
                        id: '',
                        product_category_id: '',
                        unity_id: '',
                        provider_id: '',
                        nome: '',
                        codigo_interno: '',
                        codigo_barras: '',
                        movimenta_estoque: true,
                        emitir_nf: false,
                        possui_variacao: false,
                        possui_juros: false,
                        ativo: true,
                        juros: 0,
                        peso: 0,
                        largura: 0,
                        altura: 0,
                        cumprimento: 0,
                        comissao: 0,
                        imagem: '',
                        observacao: '',
                        product_grids: [
                            {
                                codigo_identificacao: '',
                                estoque_minimo: 0,
                                estoque_maximo: 0,
                                estoque_atual: 0,
                                valor_custo: 0,
                                valor_despesas: 0,
                                valor_custo_final: 0,
                                valor_venda: 0,
                                porcentagem_lucro: 0,
                                variations: [],
                            }
                        ],
                    }
                },
            }
        },
        data() {
            return {
                grades: [],
                upload: null,
                imagePreview: null,
                categories: '',
                unities: '',
                grids: '',
                providers: '',
                errors_product_grids: {
                    errors: {
                        codigo_identificacao: '',
                        estoque_minimo: '',
                        estoque_maximo: '',
                        estoque_atual: '',
                        valor_custo: '',
                        valor_despesas: '',
                        valor_custo_final: '',
                        valor_venda: '',
                        porcentagem_lucro: '',
                    }
                },
                errors_product: {
                    id: '',
                    product_category_id: '',
                    unity_id: '',
                    provider_id: '',
                    nome: '',
                    codigo_interno: '',
                    codigo_barras: '',
                    movimenta_estoque: '',
                    emitir_nf: '',
                    possui_variacao: '',
                    possui_juros: '',
                    ativo: '',
                    juros: '',
                    peso: '',
                    largura: '',
                    altura: '',
                    cumprimento: '',
                    comissao: '',
                    imagem: '',
                    observacao: '',
                },
            }
        },

        created() {
            this.loadCategories()
            this.loadUnities()
            this.loadGrid()
            if (this.checkGrades) {
                this.grades = this.checkGrades
            }
        },

        watch: {

            'formData.product_grids': {
                handler: function (after) {
                    if (Array.isArray(after)) {
                        after.forEach((item, index) => {
                            let custoFinal = (item.valor_custo + item.valor_despesas)
                            this.formData.product_grids[index].valor_custo_final = custoFinal
                        })
                    }
                },
                deep: true
            }
        },

        methods: {

            onImage(e) {
                let files = e.target.files || e.dataTransfer.files
                if (!files) return
                this.upload = files[0]
                this.previewImage(files[0])
            },

            previewImage(file) {
                let reader = new FileReader()
                reader.onload = (e) => {
                    this.imagePreview = e.target.result
                }
                reader.readAsDataURL(file)
            },

            removeImagePreview() {
                this.imagePreview = null
                this.upload = null
            },

            removeImageData() {
                this.formData.imagem = ''
            },

            calcularVenda(index) {
                const custoFinal = this.formData.product_grids[index].valor_custo_final
                const porcentagemLucro = this.formData.product_grids[index].porcentagem_lucro
                const valorVenda = ((porcentagemLucro * custoFinal) / 100) + custoFinal
                this.formData.product_grids[index].valor_venda = valorVenda
            },

            calcularPorcentagem(index) {
                const valorVenda = this.formData.product_grids[index].valor_venda
                const custoFinal = this.formData.product_grids[index].valor_custo_final
                const lucro = valorVenda - custoFinal
                const porcentagemLucro = (100 * lucro) / custoFinal
                this.formData.product_grids[index].porcentagem_lucro = porcentagemLucro
            },
            onSubmit() {
                const data = new FormData();

                if (this.upload != null) {
                    data.append('imagem', this.upload)
                }
                data.append('stringImagem', this.formData.imagem)
                data.append('id', this.formData.id)
                data.append('product_category_id', this.formData.product_category_id)
                data.append('unity_id', this.formData.unity_id)
                data.append('provider_id', this.formData.provider_id)
                data.append('nome', this.formData.nome)
                data.append('codigo_interno', this.formData.codigo_interno)
                data.append('codigo_barras', this.formData.codigo_barras)
                data.append('movimenta_estoque', this.formData.movimenta_estoque ? 1 : 0)
                data.append('emitir_nf', this.formData.emitir_nf ? 1 : 0)
                data.append('possui_variacao', this.formData.possui_variacao ? 1 : 0)
                data.append('possui_juros', this.formData.possui_juros ? 1 : 0)
                data.append('ativo', this.formData.ativo ? 1 : 0)
                data.append('juros', this.formData.juros)
                data.append('peso', this.formData.peso)
                data.append('largura', this.formData.largura)
                data.append('altura', this.formData.altura)
                data.append('cumprimento', this.formData.cumprimento)
                data.append('comissao', this.formData.comissao)
                data.append('observacao', this.formData.observacao)

                const action = this.isUpdate ? 'updateProduct' : 'storeProduct'
                const message = this.isUpdate ? 'Produto editado com sucesso' : 'Produto cadastrado com sucesso'

                this.formData.product_grids.forEach((grid) => {
                    data.append(`product_grids[]`, JSON.stringify(grid))
                })

                this.$store.dispatch(action, data)
                    .then(() => {
                        this.$snotify.success(message)
                        this.$router.push({name: 'products'})
                    })
                    .catch((error) => {
                        if (error.response.data.hasOwnProperty('key') && error.response.data.location == 'grids') {
                            this.errors_product_grids = error.response.data
                        }
                        else if (error.response.data.hasOwnProperty('key') && error.response.data.location == 'variations') {
                            this.$snotify.error('Variação do produto não pode ser nulo', 'Erro')
                        }
                        else {
                            this.errors_product = error.response.data.errors
                        }
                        this.$snotify.error('Verifique o formulário', 'Erro')
                    })
            },

            gerarCodigoInterno() {
                this.formData.codigo_interno = moment().format('YMMDDhmm') + Math.floor(Math.random() * 999)
            },

            gerarCodigoIdentificacao(index) {
                this.formData.product_grids[index].codigo_identificacao =
                    moment().format('YMMDDhmm') + Math.floor(Math.random() * 999)
            },
            addVariation(grade) {
                this.formData.product_grids.forEach((grid) => {
                    let pruductVariation = _.map(grade, (data) => {
                        let variations = {
                            variation_id: '',
                            product_grid_id: '',
                            gradeName: data.name,
                            variations: data.variations
                        }
                        return variations
                    })
                    grid.variations = pruductVariation
                })

            },

            addGrid() {
                this.formData.product_grids.push({
                    codigo_identificacao: '',
                    estoque_minimo: '',
                    estoque_maximo: '',
                    estoque_atual: '',
                    valor_custo: '',
                    valor_despesas: '',
                    valor_custo_final: '',
                    valor_venda: '',
                    porcentagem_lucro: ''
                })
                this.addVariation(this.grades)
            },

            removeGrid(index) {
                this.formData.product_grids.splice(index, 1)
            },

            loadCategories() {
                this.$store.dispatch('loadProductCategories', {select: 'select'})
                    .then((response) => {
                        this.categories = response
                    })
            },
            loadUnities() {
                this.$store.dispatch('loadUnities')
                    .then((response) => {
                        this.unities = response
                    })
            },
            loadGrid() {
                this.$store.dispatch('loadGrids')
                    .then((response) => {
                        this.grids = response
                    })
            },
            loadProviders() {
                if (this.providers == '') {
                    this.$store.dispatch('loadProviders', {select: 'select'})
                        .then((response) => {
                            this.providers = response
                        })
                }
            },

            backPage() {
                this.$router.push({name: 'products'})
            }

        },

        computed: {
            isBtnPreload() {
                return this.$store.state.preload.btnLoading
            },

            tenant() {
                return this.$store.state.auth.data.tenant
            },
        }
    }
</script>

<style scoped="">
    .image-preview {
        margin-bottom: 10px;
        width: 170px;
        height: 170px;
    }

    label {
        margin-right: 10px;
    }

    .btn-file {
        position: relative;
        overflow: hidden;
    }

    .btn-file input[type=file] {
        position: absolute;
        top: 0;
        right: 0;
        min-width: 100%;
        min-height: 100%;
        font-size: 100px;
        text-align: right;
        filter: alpha(opacity=0);
        opacity: 0;
        outline: none;
        background: white;
        cursor: inherit;
        display: block;
    }
</style>